/* gnubiff -- a mail notification program
 * Copyright (C) 2000-2003 Nicolas Rougier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

// ===================================================================
/**
   @class AppletGNOME
   @brief Applet for GNOME version of gnubiff

   This is the applet class for the GNOME version of gnubiff
*/
// ===================================================================

#ifndef _APPLET_GNOME_H
#define _APPLET_GNOME_H

#ifdef HAVE_CONFIG_H
#   include "../config/config.h"
#endif
#include <gnome.h>
#include <panel-applet.h>
#include <panel-applet-gconf.h>
#include "Applet.h"


// ===================================================================
// - Constant definitions --------------------------------------------
// ===================================================================


using namespace std;
class AppletGNOME : public Applet {
  // ===================================================================
  // - Public methods --------------------------------------------------
  // ===================================================================
public:
  //! @name Base functions
  AppletGNOME (class Biff *owner, string xmlFilename);
  ~AppletGNOME (void);
  //@}

  //! @name Object manipulations
  void dock (GtkWidget *applet);
  void update (void);
  void show (string name = "dialog");
  void hide (string name = "dialog");
  // @}


  //! @name Callbacks
  gboolean on_change_orient (void);
  gboolean on_change_size (void);
  gboolean on_button_press (GdkEventButton *event);
  void on_menu_properties (BonoboUIComponent *uic, const gchar *verbname);
  void on_menu_mail_app (BonoboUIComponent *uic, const gchar *verbname);
  void on_menu_about (BonoboUIComponent *uic, const gchar *verbname);
  // @}


  // ===================================================================
  // - Public attributes -----------------------------------------------
  // ===================================================================
public:



  // ===================================================================
  // - Protected methods -----------------------------------------------
  // ===================================================================
protected:

  // ===================================================================
  // - Protected attributes --------------------------------------------
  // ===================================================================
protected:



  // ===================================================================
  // - Private methods -------------------------------------------------
  // ===================================================================
private:

  // ===================================================================
  // - Private attributes ----------------------------------------------
  // ===================================================================
private:
  GtkWidget *	_gnome_applet;		/*!< \brief GNOME panel applet container */
  GtkWidget *	_about;			/*!< \brief GNOME about window */
};

#endif /* _APPLET_GNOME_H */
