/* gnubiff -- a mail notification program
 * Copyright (C) 2000-2003 Nicolas Rougier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

// ===================================================================
/**
   @class Pop
   @brief generic POP protocol for Pop3 and Apop

*/
// ===================================================================

#ifndef _POP_H
#define _POP_H

#ifdef HAVE_CONFIG_H
#   include "../config/config.h"
#endif
#include "Mailbox.h"


// ===================================================================
// = Some useful macros (as always) ==================================
// ===================================================================
#ifdef CHECK_SOCKET
#  undef CHECK_SOCKET
#endif
#define CHECK_SOCKET		if (_socket_status == SOCKET_STATUS_ERROR) {socket_close(); return;}
#ifdef CHECK_SERVER_RESPONSE
# undef CHECK_SERVER_RESPONSE
#endif
#define CHECK_SERVER_RESPONSE	CHECK_SOCKET; if (line.find ("-ERR") == 0) {_socket_status = SOCKET_STATUS_ERROR; return;}


// ===================================================================
// - Constant definitions --------------------------------------------
// ===================================================================


using namespace std;
class Pop : public Mailbox {
  // ===================================================================
  // - Public methods --------------------------------------------------
  // ===================================================================
public:
  //! @name Base functions
  Pop (class Biff *owner);
  ~Pop (void);
  //@}

  //! @name I/O functions
  void update (void);
  void fetch (void);
  // @}

  // ===================================================================
  // - Public attributes -----------------------------------------------
  // ===================================================================
public:



  // ===================================================================
  // - Protected methods -----------------------------------------------
  // ===================================================================
protected:
  /**
     Connect to the server and authenticate user
  */
  virtual void connect (void) = 0;

  // ===================================================================
  // - Protected attributes --------------------------------------------
  // ===================================================================
protected:
  vector<string> _saved;	/*!< \brief  Saved UIDL list */



  // ===================================================================
  // - Private methods -------------------------------------------------
  // ===================================================================
private:

  // ===================================================================
  // - Private attributes ----------------------------------------------
  // ===================================================================
private:
};

#endif /* _POP_H */
